diff -ruN vdr-1.7.12/dvbdevice.c vdr-1.7.13/dvbdevice.c
--- vdr-1.7.12/dvbdevice.c	2010-01-04 15:06:24.000000000 +0100
+++ vdr-1.7.13/dvbdevice.c	2010-02-21 18:10:35.000000000 +0100
@@ -4,10 +4,11 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: dvbdevice.c 2.24 2010/01/04 14:06:24 kls Exp $
+ * $Id: dvbdevice.c 2.29 2010/02/21 17:10:35 kls Exp $
  */
 
 #include "dvbdevice.h"
+#include <ctype.h>
 #include <errno.h>
 #include <limits.h>
 #include <linux/dvb/dmx.h>
@@ -17,6 +18,8 @@
 #include "channels.h"
 #include "diseqc.h"
 #include "dvbci.h"
+#include "menuitems.h"
+#include "sourceparams.h"
 
 #define DVBS_TUNE_TIMEOUT  9000 //ms
 #define DVBS_LOCK_TIMEOUT  2000 //ms
@@ -25,11 +28,223 @@
 #define DVBT_TUNE_TIMEOUT  9000 //ms
 #define DVBT_LOCK_TIMEOUT  2000 //ms
 
+// --- DVB Parameter Maps ----------------------------------------------------
+
+const tDvbParameterMap InversionValues[] = {
+  {   0, INVERSION_OFF,  trNOOP("off") },
+  {   1, INVERSION_ON,   trNOOP("on") },
+  { 999, INVERSION_AUTO, trNOOP("auto") },
+  {  -1, 0, NULL }
+  };
+
+const tDvbParameterMap BandwidthValues[] = {
+  {   6, 6000000, "6 MHz" },
+  {   7, 7000000, "7 MHz" },
+  {   8, 8000000, "8 MHz" },
+  {  -1, 0, NULL }
+  };
+
+const tDvbParameterMap CoderateValues[] = {
+  {   0, FEC_NONE, trNOOP("none") },
+  {  12, FEC_1_2,  "1/2" },
+  {  23, FEC_2_3,  "2/3" },
+  {  34, FEC_3_4,  "3/4" },
+  {  35, FEC_3_5,  "3/5" },
+  {  45, FEC_4_5,  "4/5" },
+  {  56, FEC_5_6,  "5/6" },
+  {  67, FEC_6_7,  "6/7" },
+  {  78, FEC_7_8,  "7/8" },
+  {  89, FEC_8_9,  "8/9" },
+  { 910, FEC_9_10, "9/10" },
+  { 999, FEC_AUTO, trNOOP("auto") },
+  {  -1, 0, NULL }
+  };
+
+const tDvbParameterMap ModulationValues[] = {
+  {  16, QAM_16,   "QAM16" },
+  {  32, QAM_32,   "QAM32" },
+  {  64, QAM_64,   "QAM64" },
+  { 128, QAM_128,  "QAM128" },
+  { 256, QAM_256,  "QAM256" },
+  {   2, QPSK,     "QPSK" },
+  {   5, PSK_8,    "8PSK" },
+  {   6, APSK_16,  "16APSK" },
+  {  10, VSB_8,    "VSB8" },
+  {  11, VSB_16,   "VSB16" },
+  { 998, QAM_AUTO, "QAMAUTO" },
+  {  -1, 0, NULL }
+  };
+
+const tDvbParameterMap SystemValues[] = {
+  {   0, SYS_DVBS,  "DVB-S" },
+  {   1, SYS_DVBS2, "DVB-S2" },
+  {  -1, 0, NULL }
+  };
+
+const tDvbParameterMap TransmissionValues[] = {
+  {   2, TRANSMISSION_MODE_2K,   "2K" },
+  {   8, TRANSMISSION_MODE_8K,   "8K" },
+  { 999, TRANSMISSION_MODE_AUTO, trNOOP("auto") },
+  {  -1, 0, NULL }
+  };
+
+const tDvbParameterMap GuardValues[] = {
+  {   4, GUARD_INTERVAL_1_4,  "1/4" },
+  {   8, GUARD_INTERVAL_1_8,  "1/8" },
+  {  16, GUARD_INTERVAL_1_16, "1/16" },
+  {  32, GUARD_INTERVAL_1_32, "1/32" },
+  { 999, GUARD_INTERVAL_AUTO, trNOOP("auto") },
+  {  -1, 0, NULL }
+  };
+
+const tDvbParameterMap HierarchyValues[] = {
+  {   0, HIERARCHY_NONE, trNOOP("none") },
+  {   1, HIERARCHY_1,    "1" },
+  {   2, HIERARCHY_2,    "2" },
+  {   4, HIERARCHY_4,    "4" },
+  { 999, HIERARCHY_AUTO, trNOOP("auto") },
+  {  -1, 0, NULL }
+  };
+
+const tDvbParameterMap RollOffValues[] = {
+  {   0, ROLLOFF_AUTO, trNOOP("auto") },
+  {  20, ROLLOFF_20, "0.20" },
+  {  25, ROLLOFF_25, "0.25" },
+  {  35, ROLLOFF_35, "0.35" },
+  {  -1, 0, NULL }
+  };
+
+int UserIndex(int Value, const tDvbParameterMap *Map)
+{
+  const tDvbParameterMap *map = Map;
+  while (map && map->userValue != -1) {
+        if (map->userValue == Value)
+           return map - Map;
+        map++;
+        }
+  return -1;
+}
+
+int DriverIndex(int Value, const tDvbParameterMap *Map)
+{
+  const tDvbParameterMap *map = Map;
+  while (map && map->userValue != -1) {
+        if (map->driverValue == Value)
+           return map - Map;
+        map++;
+        }
+  return -1;
+}
+
+int MapToUser(int Value, const tDvbParameterMap *Map, const char **String)
+{
+  int n = DriverIndex(Value, Map);
+  if (n >= 0) {
+     if (String)
+        *String = tr(Map[n].userString);
+     return Map[n].userValue;
+     }
+  return -1;
+}
+
+int MapToDriver(int Value, const tDvbParameterMap *Map)
+{
+  int n = UserIndex(Value, Map);
+  if (n >= 0)
+     return Map[n].driverValue;
+  return -1;
+}
+
+// --- cDvbTransponderParameters ---------------------------------------------
+
+cDvbTransponderParameters::cDvbTransponderParameters(const char *Parameters)
+{
+  polarization = 0;
+  inversion    = INVERSION_AUTO;
+  bandwidth    = 8000000;
+  coderateH    = FEC_AUTO;
+  coderateL    = FEC_AUTO;
+  modulation   = QPSK;
+  system       = SYS_DVBS;
+  transmission = TRANSMISSION_MODE_AUTO;
+  guard        = GUARD_INTERVAL_AUTO;
+  hierarchy    = HIERARCHY_AUTO;
+  rollOff      = ROLLOFF_AUTO;
+  Parse(Parameters);
+}
+
+int cDvbTransponderParameters::PrintParameter(char *p, char Name, int Value) const
+{
+  return Value >= 0 && Value != 999 ? sprintf(p, "%c%d", Name, Value) : 0;
+}
+
+cString cDvbTransponderParameters::ToString(char Type) const
+{
+#define ST(s) if (strchr(s, Type))
+  char buffer[64];
+  char *q = buffer;
+  *q = 0;
+  ST(" S ")  q += sprintf(q, "%c", polarization);
+  ST("  T")  q += PrintParameter(q, 'B', MapToUser(bandwidth, BandwidthValues));
+  ST("CST")  q += PrintParameter(q, 'C', MapToUser(coderateH, CoderateValues));
+  ST("  T")  q += PrintParameter(q, 'D', MapToUser(coderateL, CoderateValues));
+  ST("  T")  q += PrintParameter(q, 'G', MapToUser(guard, GuardValues));
+  ST("CST")  q += PrintParameter(q, 'I', MapToUser(inversion, InversionValues));
+  ST("CST")  q += PrintParameter(q, 'M', MapToUser(modulation, ModulationValues));
+  ST(" S ")  q += PrintParameter(q, 'O', MapToUser(rollOff, RollOffValues));
+  ST(" S ")  q += PrintParameter(q, 'S', MapToUser(system, SystemValues));
+  ST("  T")  q += PrintParameter(q, 'T', MapToUser(transmission, TransmissionValues));
+  ST("  T")  q += PrintParameter(q, 'Y', MapToUser(hierarchy, HierarchyValues));
+  return buffer;
+}
+
+const char *cDvbTransponderParameters::ParseParameter(const char *s, int &Value, const tDvbParameterMap *Map)
+{
+  if (*++s) {
+     char *p = NULL;
+     errno = 0;
+     int n = strtol(s, &p, 10);
+     if (!errno && p != s) {
+        Value = MapToDriver(n, Map);
+        if (Value >= 0)
+           return p;
+        }
+     }
+  esyslog("ERROR: invalid value for parameter '%c'", *(s - 1));
+  return NULL;
+}
+
+bool cDvbTransponderParameters::Parse(const char *s)
+{
+  while (s && *s) {
+        switch (toupper(*s)) {
+          case 'B': s = ParseParameter(s, bandwidth, BandwidthValues); break;
+          case 'C': s = ParseParameter(s, coderateH, CoderateValues); break;
+          case 'D': s = ParseParameter(s, coderateL, CoderateValues); break;
+          case 'G': s = ParseParameter(s, guard, GuardValues); break;
+          case 'H': polarization = *s++; break;
+          case 'I': s = ParseParameter(s, inversion, InversionValues); break;
+          case 'L': polarization = *s++; break;
+          case 'M': s = ParseParameter(s, modulation, ModulationValues); break;
+          case 'O': s = ParseParameter(s, rollOff, RollOffValues); break;
+          case 'R': polarization = *s++; break;
+          case 'S': s = ParseParameter(s, system, SystemValues); break;
+          case 'T': s = ParseParameter(s, transmission, TransmissionValues); break;
+          case 'V': polarization = *s++; break;
+          case 'Y': s = ParseParameter(s, hierarchy, HierarchyValues); break;
+          default: esyslog("ERROR: unknown parameter key '%c'", *s);
+                   return false;
+          }
+        }
+  return true;
+}
+
 // --- cDvbTuner -------------------------------------------------------------
 
 class cDvbTuner : public cThread {
 private:
   enum eTunerStatus { tsIdle, tsSet, tsTuned, tsLocked };
+  int device;
   int fd_frontend;
   int adapter, frontend;
   int tuneTimeout;
@@ -46,15 +261,17 @@
   bool SetFrontend(void);
   virtual void Action(void);
 public:
-  cDvbTuner(int Fd_Frontend, int Adapter, int Frontend, fe_delivery_system FrontendType);
+  cDvbTuner(int Device, int Fd_Frontend, int Adapter, int Frontend, fe_delivery_system FrontendType);
   virtual ~cDvbTuner();
+  const cChannel *GetTransponder(void) const { return &channel; }
   bool IsTunedTo(const cChannel *Channel) const;
   void Set(const cChannel *Channel);
   bool Locked(int TimeoutMs = 0);
   };
 
-cDvbTuner::cDvbTuner(int Fd_Frontend, int Adapter, int Frontend, fe_delivery_system FrontendType)
+cDvbTuner::cDvbTuner(int Device, int Fd_Frontend, int Adapter, int Frontend, fe_delivery_system FrontendType)
 {
+  device = Device;
   fd_frontend = Fd_Frontend;
   adapter = Adapter;
   frontend = Frontend;
@@ -84,21 +301,8 @@
      return false; // not tuned to
   if (channel.Source() != Channel->Source() || channel.Transponder() != Channel->Transponder())
      return false; // sufficient mismatch
-  char Type = **cSource::ToString(Channel->Source());
-#define ST(s, p) if (strchr(s, Type)) if (channel.p() != Channel->p()) return false;
   // Polarization is already checked as part of the Transponder.
-  ST("  T", Bandwidth);
-  ST("CST", CoderateH);
-  ST("  T", CoderateL);
-  ST("  T", Guard);
-  ST("CST", Inversion);
-  ST("CST", Modulation);
-  ST(" S ", RollOff);
-  ST(" S ", System);
-  ST("CS ", Srate);
-  ST("  T", Transmission);
-  ST("  T", Hierarchy);
-  return true;
+  return strcmp(channel.Parameters(), Channel->Parameters()) == 0;
 }
 
 void cDvbTuner::Set(const cChannel *Channel)
@@ -171,10 +375,12 @@
      }
   CmdSeq.num = 0;
 
+  cDvbTransponderParameters dtp(channel.Parameters());
+
   if (frontendType == SYS_DVBS || frontendType == SYS_DVBS2) {
      unsigned int frequency = channel.Frequency();
      if (Setup.DiSEqC) {
-        cDiseqc *diseqc = Diseqcs.Get(channel.Source(), channel.Frequency(), channel.Polarization());
+        cDiseqc *diseqc = Diseqcs.Get(device, channel.Source(), channel.Frequency(), dtp.Polarization());
         if (diseqc) {
            if (diseqc->Commands() && (!diseqcCommands || strcmp(diseqcCommands, diseqc->Commands()) != 0)) {
               cDiseqc::eDiseqcActions da;
@@ -220,24 +426,24 @@
            frequency -= Setup.LnbFrequHi;
            tone = SEC_TONE_ON;
            }
-        int volt = (channel.Polarization() == 'v' || channel.Polarization() == 'V' || channel.Polarization() == 'r' || channel.Polarization() == 'R') ? SEC_VOLTAGE_13 : SEC_VOLTAGE_18;
+        int volt = (dtp.Polarization() == 'v' || dtp.Polarization() == 'V' || dtp.Polarization() == 'r' || dtp.Polarization() == 'R') ? SEC_VOLTAGE_13 : SEC_VOLTAGE_18;
         CHECK(ioctl(fd_frontend, FE_SET_VOLTAGE, volt));
         CHECK(ioctl(fd_frontend, FE_SET_TONE, tone));
         }
      frequency = abs(frequency); // Allow for C-band, where the frequency is less than the LOF
 
      // DVB-S/DVB-S2 (common parts)
-     SETCMD(DTV_DELIVERY_SYSTEM, channel.System());
+     SETCMD(DTV_DELIVERY_SYSTEM, dtp.System());
      SETCMD(DTV_FREQUENCY, frequency * 1000UL);
-     SETCMD(DTV_MODULATION, channel.Modulation());
+     SETCMD(DTV_MODULATION, dtp.Modulation());
      SETCMD(DTV_SYMBOL_RATE, channel.Srate() * 1000UL);
-     SETCMD(DTV_INNER_FEC, channel.CoderateH());
-     SETCMD(DTV_INVERSION, channel.Inversion());
-     if (channel.System() == SYS_DVBS2) {
+     SETCMD(DTV_INNER_FEC, dtp.CoderateH());
+     SETCMD(DTV_INVERSION, dtp.Inversion());
+     if (dtp.System() == SYS_DVBS2) {
         if (frontendType == SYS_DVBS2) {
            // DVB-S2
            SETCMD(DTV_PILOT, PILOT_AUTO);
-           SETCMD(DTV_ROLLOFF, channel.RollOff());
+           SETCMD(DTV_ROLLOFF, dtp.RollOff());
            }
         else {
            esyslog("ERROR: frontend %d/%d doesn't provide DVB-S2", adapter, frontend);
@@ -256,10 +462,10 @@
      // DVB-C
      SETCMD(DTV_DELIVERY_SYSTEM, frontendType);
      SETCMD(DTV_FREQUENCY, FrequencyToHz(channel.Frequency()));
-     SETCMD(DTV_INVERSION, channel.Inversion());
+     SETCMD(DTV_INVERSION, dtp.Inversion());
      SETCMD(DTV_SYMBOL_RATE, channel.Srate() * 1000UL);
-     SETCMD(DTV_INNER_FEC, channel.CoderateH());
-     SETCMD(DTV_MODULATION, channel.Modulation());
+     SETCMD(DTV_INNER_FEC, dtp.CoderateH());
+     SETCMD(DTV_MODULATION, dtp.Modulation());
 
      tuneTimeout = DVBC_TUNE_TIMEOUT;
      lockTimeout = DVBC_LOCK_TIMEOUT;
@@ -268,14 +474,14 @@
      // DVB-T
      SETCMD(DTV_DELIVERY_SYSTEM, frontendType);
      SETCMD(DTV_FREQUENCY, FrequencyToHz(channel.Frequency()));
-     SETCMD(DTV_INVERSION, channel.Inversion());
-     SETCMD(DTV_BANDWIDTH_HZ, channel.Bandwidth());
-     SETCMD(DTV_CODE_RATE_HP, channel.CoderateH());
-     SETCMD(DTV_CODE_RATE_LP, channel.CoderateL());
-     SETCMD(DTV_MODULATION, channel.Modulation());
-     SETCMD(DTV_TRANSMISSION_MODE, channel.Transmission());
-     SETCMD(DTV_GUARD_INTERVAL, channel.Guard());
-     SETCMD(DTV_HIERARCHY, channel.Hierarchy());
+     SETCMD(DTV_INVERSION, dtp.Inversion());
+     SETCMD(DTV_BANDWIDTH_HZ, dtp.Bandwidth());
+     SETCMD(DTV_CODE_RATE_HP, dtp.CoderateH());
+     SETCMD(DTV_CODE_RATE_LP, dtp.CoderateL());
+     SETCMD(DTV_MODULATION, dtp.Modulation());
+     SETCMD(DTV_TRANSMISSION_MODE, dtp.Transmission());
+     SETCMD(DTV_GUARD_INTERVAL, dtp.Guard());
+     SETCMD(DTV_HIERARCHY, dtp.Hierarchy());
 
      tuneTimeout = DVBT_TUNE_TIMEOUT;
      lockTimeout = DVBT_LOCK_TIMEOUT;
@@ -353,6 +559,62 @@
         }
 }
 
+// --- cDvbSourceParam -------------------------------------------------------
+
+class cDvbSourceParam : public cSourceParam {
+private:
+  int param;
+  cChannel data;
+  cDvbTransponderParameters dtp;
+public:
+  cDvbSourceParam(char Source, const char *Description);
+  virtual void SetData(cChannel *Channel);
+  virtual void GetData(cChannel *Channel);
+  virtual cOsdItem *GetOsdItem(void);
+  };
+
+cDvbSourceParam::cDvbSourceParam(char Source, const char *Description)
+:cSourceParam(Source, Description)
+{
+  param = 0;
+}
+
+void cDvbSourceParam::SetData(cChannel *Channel)
+{
+  data = *Channel;
+  dtp.Parse(data.Parameters());
+  param = 0;
+}
+
+void cDvbSourceParam::GetData(cChannel *Channel)
+{
+  data.SetTransponderData(Channel->Source(), Channel->Frequency(), data.Srate(), dtp.ToString(Source()), true);
+  *Channel = data;
+}
+
+cOsdItem *cDvbSourceParam::GetOsdItem(void)
+{
+  char type = Source();
+#undef ST
+#define ST(s) if (strchr(s, type))
+  switch (param++) {
+    case  0: ST(" S ")  return new cMenuEditChrItem( tr("Polarization"), &dtp.polarization, "hvlr");             else return GetOsdItem();
+    case  1: ST(" S ")  return new cMenuEditMapItem( tr("System"),       &dtp.system,       SystemValues);       else return GetOsdItem();
+    case  2: ST("CS ")  return new cMenuEditIntItem( tr("Srate"),        &data.srate);                           else return GetOsdItem();
+    case  3: ST("CST")  return new cMenuEditMapItem( tr("Inversion"),    &dtp.inversion,    InversionValues);    else return GetOsdItem();
+    case  4: ST("CST")  return new cMenuEditMapItem( tr("CoderateH"),    &dtp.coderateH,    CoderateValues);     else return GetOsdItem();
+    case  5: ST("  T")  return new cMenuEditMapItem( tr("CoderateL"),    &dtp.coderateL,    CoderateValues);     else return GetOsdItem();
+    case  6: ST("CST")  return new cMenuEditMapItem( tr("Modulation"),   &dtp.modulation,   ModulationValues);   else return GetOsdItem();
+    case  7: ST("  T")  return new cMenuEditMapItem( tr("Bandwidth"),    &dtp.bandwidth,    BandwidthValues);    else return GetOsdItem();
+    case  8: ST("  T")  return new cMenuEditMapItem( tr("Transmission"), &dtp.transmission, TransmissionValues); else return GetOsdItem();
+    case  9: ST("  T")  return new cMenuEditMapItem( tr("Guard"),        &dtp.guard,        GuardValues);        else return GetOsdItem();
+    case 10: ST("  T")  return new cMenuEditMapItem( tr("Hierarchy"),    &dtp.hierarchy,    HierarchyValues);    else return GetOsdItem();
+    case 11: ST(" S ")  return new cMenuEditMapItem( tr("Rolloff"),      &dtp.rollOff,      RollOffValues);      else return GetOsdItem();
+    default: return NULL;
+    }
+  return NULL;
+}
+
 // --- cDvbDevice ------------------------------------------------------------
 
 int cDvbDevice::setTransferModeForDolbyDigital = 1;
@@ -419,7 +681,7 @@
         if (frontendType == SYS_DVBS2)
            numProvidedSystems++;
         isyslog("frontend %d/%d provides %s (\"%s\")", adapter, frontend, DeliverySystems[frontendType], frontendInfo.name);
-        dvbTuner = new cDvbTuner(fd_frontend, adapter, frontend, frontendType);
+        dvbTuner = new cDvbTuner(CardIndex() + 1, fd_frontend, adapter, frontend, frontendType);
         }
      }
   else
@@ -483,6 +745,9 @@
 
 bool cDvbDevice::Initialize(void)
 {
+  new cDvbSourceParam('C', "DVB-C");
+  new cDvbSourceParam('S', "DVB-S");
+  new cDvbSourceParam('T', "DVB-T");
   int Checked = 0;
   int Found = 0;
   for (int Adapter = 0; ; Adapter++) {
@@ -608,10 +873,13 @@
   if (!ProvidesSource(Channel->Source()))
      return false; // doesn't provide source
   if (!cSource::IsSat(Channel->Source()))
-     return true; // source is sufficient for non sat
-  if (frontendType == SYS_DVBS && Channel->System() == SYS_DVBS2)
+     return DeviceHooksProvidesTransponder(Channel); // source is sufficient for non sat
+  cDvbTransponderParameters dtp(Channel->Parameters());
+  if (frontendType == SYS_DVBS && dtp.System() == SYS_DVBS2)
      return false; // requires modulation system which frontend doesn't provide
-  return !Setup.DiSEqC || Diseqcs.Get(Channel->Source(), Channel->Frequency(), Channel->Polarization());
+  if (!Setup.DiSEqC || Diseqcs.Get(CardIndex() + 1, Channel->Source(), Channel->Frequency(), dtp.Polarization()))
+     return DeviceHooksProvidesTransponder(Channel);
+  return false;
 }
 
 bool cDvbDevice::ProvidesChannel(const cChannel *Channel, int Priority, bool *NeedsDetachReceivers) const
@@ -653,6 +921,11 @@
   return numProvidedSystems;
 }
 
+const cChannel *cDvbDevice::GetCurrentlyTunedTransponder(void) const
+{
+  return dvbTuner->GetTransponder(); 
+}
+
 bool cDvbDevice::IsTunedToTransponder(const cChannel *Channel)
 {
   return dvbTuner->IsTunedTo(Channel);
diff -ruN vdr-1.7.12/dvbdevice.h vdr-1.7.13/dvbdevice.h
--- vdr-1.7.12/dvbdevice.h	2010-01-04 15:07:12.000000000 +0100
+++ vdr-1.7.13/dvbdevice.h	2010-02-21 15:06:08.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: dvbdevice.h 2.11 2010/01/04 14:07:12 kls Exp $
+ * $Id: dvbdevice.h 2.13 2010/02/21 14:06:08 kls Exp $
  */
 
 #ifndef __DVBDEVICE_H
@@ -31,6 +31,71 @@
 #define DEV_DVB_AUDIO     "audio"
 #define DEV_DVB_CA        "ca"
 
+struct tDvbParameterMap {
+  int userValue;
+  int driverValue;
+  const char *userString;
+  };
+
+int MapToUser(int Value, const tDvbParameterMap *Map, const char **String = NULL);
+int MapToDriver(int Value, const tDvbParameterMap *Map);
+int UserIndex(int Value, const tDvbParameterMap *Map);
+int DriverIndex(int Value, const tDvbParameterMap *Map);
+
+extern const tDvbParameterMap InversionValues[];
+extern const tDvbParameterMap BandwidthValues[];
+extern const tDvbParameterMap CoderateValues[];
+extern const tDvbParameterMap ModulationValues[];
+extern const tDvbParameterMap SystemValues[];
+extern const tDvbParameterMap TransmissionValues[];
+extern const tDvbParameterMap GuardValues[];
+extern const tDvbParameterMap HierarchyValues[];
+extern const tDvbParameterMap RollOffValues[];
+
+class cDvbTransponderParameters {
+friend class cDvbSourceParam;
+private:
+  char polarization;
+  int inversion;
+  int bandwidth;
+  int coderateH;
+  int coderateL;
+  int modulation;
+  int system;
+  int transmission;
+  int guard;
+  int hierarchy;
+  int rollOff;
+  int PrintParameter(char *p, char Name, int Value) const;
+  const char *ParseParameter(const char *s, int &Value, const tDvbParameterMap *Map);
+public:
+  cDvbTransponderParameters(const char *Parameters = NULL);
+  char Polarization(void) const { return polarization; }
+  int Inversion(void) const { return inversion; }
+  int Bandwidth(void) const { return bandwidth; }
+  int CoderateH(void) const { return coderateH; }
+  int CoderateL(void) const { return coderateL; }
+  int Modulation(void) const { return modulation; }
+  int System(void) const { return system; }
+  int Transmission(void) const { return transmission; }
+  int Guard(void) const { return guard; }
+  int Hierarchy(void) const { return hierarchy; }
+  int RollOff(void) const { return rollOff; }
+  void SetPolarization(char Polarization) { polarization = Polarization; }
+  void SetInversion(int Inversion) { inversion = Inversion; }
+  void SetBandwidth(int Bandwidth) { bandwidth = Bandwidth; }
+  void SetCoderateH(int CoderateH) { coderateH = CoderateH; }
+  void SetCoderateL(int CoderateL) { coderateL = CoderateL; }
+  void SetModulation(int Modulation) { modulation = Modulation; }
+  void SetSystem(int System) { system = System; }
+  void SetTransmission(int Transmission) { transmission = Transmission; }
+  void SetGuard(int Guard) { guard = Guard; }
+  void SetHierarchy(int Hierarchy) { hierarchy = Hierarchy; }
+  void SetRollOff(int RollOff) { rollOff = RollOff; }
+  cString ToString(char Type) const;
+  bool Parse(const char *s);
+  };
+
 class cDvbTuner;
 
 /// The cDvbDevice implements a DVB device which can be accessed through the Linux DVB driver API.
@@ -75,6 +140,7 @@
   virtual bool ProvidesTransponder(const cChannel *Channel) const;
   virtual bool ProvidesChannel(const cChannel *Channel, int Priority = -1, bool *NeedsDetachReceivers = NULL) const;
   virtual int NumProvidedSystems(void) const;
+  virtual const cChannel *GetCurrentlyTunedTransponder(void) const;
   virtual bool IsTunedToTransponder(const cChannel *Channel);
 protected:
   virtual bool SetChannelDevice(const cChannel *Channel, bool LiveView);
diff -ruN vdr-1.7.12/dvbplayer.c vdr-1.7.13/dvbplayer.c
--- vdr-1.7.12/dvbplayer.c	2009-12-13 14:49:56.000000000 +0100
+++ vdr-1.7.13/dvbplayer.c	2010-02-06 13:34:28.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: dvbplayer.c 2.19 2009/12/13 13:49:56 kls Exp $
+ * $Id: dvbplayer.c 2.20 2010/02/06 12:34:28 kls Exp $
  */
 
 #include "dvbplayer.h"
@@ -396,6 +396,7 @@
   uint32_t LastStc = 0;
   int LastReadIFrame = -1;
   int SwitchToPlayFrame = 0;
+  cFrame *DropFrame = NULL;
 
   while (Running()) {
         if (WaitingForData)
@@ -502,6 +503,13 @@
           else
              Sleep = true;
 
+          if (DropFrame) {
+             if (!eof || (playDir != pdForward && DropFrame->Index() > 0) || (playDir == pdForward && DropFrame->Index() < readIndex)) {
+                ringBuffer->Drop(DropFrame); // the very first and last frame are continously repeated to flush data through the device
+                DropFrame = NULL;
+                }
+             }
+
           // Get the next frame from the buffer:
 
           if (!playFrame) {
@@ -546,8 +554,7 @@
                    Sleep = true;
                 }
              if (pc <= 0) {
-                if (!eof || (playDir != pdForward && playFrame->Index() > 0) || (playDir == pdForward && playFrame->Index() < readIndex))
-                   ringBuffer->Drop(playFrame); // the very first and last frame are continously repeated to flush data through the device
+                DropFrame = playFrame;
                 playFrame = NULL;
                 p = NULL;
                 }
diff -ruN vdr-1.7.12/dvbsubtitle.c vdr-1.7.13/dvbsubtitle.c
--- vdr-1.7.12/dvbsubtitle.c	2009-12-05 17:11:54.000000000 +0100
+++ vdr-1.7.13/dvbsubtitle.c	2010-02-07 13:08:13.000000000 +0100
@@ -7,7 +7,7 @@
  * Original author: Marco Schlüßler <marco@lordzodiac.de>
  * With some input from the "subtitle plugin" by Pekka Virtanen <pekka.virtanen@sci.fi>
  *
- * $Id: dvbsubtitle.c 2.3 2009/12/05 16:11:54 kls Exp $
+ * $Id: dvbsubtitle.c 2.4 2010/02/07 12:08:13 kls Exp $
  */
 
 #include "dvbsubtitle.h"
@@ -658,6 +658,7 @@
 {
   dvbSubtitleAssembler = new cDvbSubtitleAssembler;
   osd = NULL;
+  frozen = false;
   pages = new cList<cDvbSubtitlePage>;
   bitmaps = new cList<cDvbSubtitleBitmaps>;
   Start();
@@ -685,6 +686,7 @@
   pages->Clear();
   bitmaps->Clear();
   DELETENULL(osd);
+  frozen = false;
   Unlock();
 }
 
@@ -776,46 +778,48 @@
   int LastSetupLevel = setupLevel;
   cTimeMs Timeout;
   while (Running()) {
-        if (osd) {
-           int NewSetupLevel = setupLevel;
-           if (Timeout.TimedOut() || LastSetupLevel != NewSetupLevel) {
-              DELETENULL(osd);
-              }
-           LastSetupLevel = NewSetupLevel;
-           }
         int WaitMs = 100;
-        Lock();
-        if (cDvbSubtitleBitmaps *sb = bitmaps->First()) {
-           int64_t STC = cDevice::PrimaryDevice()->GetSTC();
-           int64_t Delta = 0;
-           if (STC >= 0) {
-              Delta = LimitTo32Bit(sb->Pts()) - LimitTo32Bit(STC); // some devices only deliver 32 bits
-              if (Delta > (int64_t(1) << 31))
-                 Delta -= (int64_t(1) << 32);
-              else if (Delta < -((int64_t(1) << 31) - 1))
-                 Delta += (int64_t(1) << 32);
-              }
-           else {
-              //TODO sync on PTS? are there actually devices that don't deliver an STC?
+        if (!frozen) {
+           if (osd) {
+              int NewSetupLevel = setupLevel;
+              if (Timeout.TimedOut() || LastSetupLevel != NewSetupLevel) {
+                 DELETENULL(osd);
+                 }
+              LastSetupLevel = NewSetupLevel;
               }
-           Delta /= 90; // STC and PTS are in 1/90000s
-           if (Delta <= MAXDELTA) {
-              if (Delta <= 0) {
-                 dbgconverter("Got %d bitmaps, showing #%d\n", bitmaps->Count(), sb->Index() + 1);
-                 if (AssertOsd()) {
-                    sb->Draw(osd);
-                    Timeout.Set(sb->Timeout() * 1000);
-                    dbgconverter("PTS: %lld  STC: %lld (%lld) timeout: %d\n", sb->Pts(), cDevice::PrimaryDevice()->GetSTC(), Delta, sb->Timeout());
+           Lock();
+           if (cDvbSubtitleBitmaps *sb = bitmaps->First()) {
+              int64_t STC = cDevice::PrimaryDevice()->GetSTC();
+              int64_t Delta = 0;
+              if (STC >= 0) {
+                 Delta = LimitTo32Bit(sb->Pts()) - LimitTo32Bit(STC); // some devices only deliver 32 bits
+                 if (Delta > (int64_t(1) << 31))
+                    Delta -= (int64_t(1) << 32);
+                 else if (Delta < -((int64_t(1) << 31) - 1))
+                    Delta += (int64_t(1) << 32);
+                 }
+              else {
+                 //TODO sync on PTS? are there actually devices that don't deliver an STC?
+                 }
+              Delta /= 90; // STC and PTS are in 1/90000s
+              if (Delta <= MAXDELTA) {
+                 if (Delta <= 0) {
+                    dbgconverter("Got %d bitmaps, showing #%d\n", bitmaps->Count(), sb->Index() + 1);
+                    if (AssertOsd()) {
+                       sb->Draw(osd);
+                       Timeout.Set(sb->Timeout() * 1000);
+                       dbgconverter("PTS: %lld  STC: %lld (%lld) timeout: %d\n", sb->Pts(), cDevice::PrimaryDevice()->GetSTC(), Delta, sb->Timeout());
+                       }
+                    bitmaps->Del(sb);
                     }
-                 bitmaps->Del(sb);
+                 else if (Delta < WaitMs)
+                    WaitMs = Delta;
                  }
-              else if (Delta < WaitMs)
-                 WaitMs = Delta;
+              else
+                 bitmaps->Del(sb);
               }
-           else
-              bitmaps->Del(sb);
+           Unlock();
            }
-        Unlock();
         cCondWait::SleepMs(WaitMs);
         }
 }
diff -ruN vdr-1.7.12/dvbsubtitle.h vdr-1.7.13/dvbsubtitle.h
--- vdr-1.7.12/dvbsubtitle.h	2008-05-25 16:36:52.000000000 +0200
+++ vdr-1.7.13/dvbsubtitle.h	2010-02-07 12:55:14.000000000 +0100
@@ -6,7 +6,7 @@
  *
  * Original author: Marco Schlüßler <marco@lordzodiac.de>
  *
- * $Id: dvbsubtitle.h 2.1 2008/05/25 14:36:52 kls Exp $
+ * $Id: dvbsubtitle.h 2.2 2010/02/07 11:55:14 kls Exp $
  */
 
 #ifndef __DVBSUBTITLE_H
@@ -25,6 +25,7 @@
   static int setupLevel;
   cDvbSubtitleAssembler *dvbSubtitleAssembler;
   cOsd *osd;
+  bool frozen;
   cList<cDvbSubtitlePage> *pages;
   cList<cDvbSubtitleBitmaps> *bitmaps;
   tColor yuv2rgb(int Y, int Cb, int Cr);
@@ -36,6 +37,7 @@
   virtual ~cDvbSubtitleConverter();
   void Action(void);
   void Reset(void);
+  void Freeze(bool Status) { frozen = Status; }
   int ConvertFragments(const uchar *Data, int Length); // for legacy PES recordings
   int Convert(const uchar *Data, int Length);
   static void SetupChanged(void);
diff -ruN vdr-1.7.12/eitscan.c vdr-1.7.13/eitscan.c
--- vdr-1.7.12/eitscan.c	2006-01-07 15:10:17.000000000 +0100
+++ vdr-1.7.13/eitscan.c	2010-02-07 13:12:05.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: eitscan.c 2.0 2006/01/07 14:10:17 kls Exp $
+ * $Id: eitscan.c 2.1 2010/02/07 12:12:05 kls Exp $
  */
 
 #include "eitscan.h"
@@ -127,7 +127,7 @@
 
 void cEITScanner::Process(void)
 {
-  if ((Setup.EPGScanTimeout || !lastActivity) && Channels.MaxNumber() > 1) { // !lastActivity means a scan was forced
+  if (Setup.EPGScanTimeout || !lastActivity) { // !lastActivity means a scan was forced
      time_t now = time(NULL);
      if (now - lastScan > ScanTimeout && now - lastActivity > ActivityTimeout) {
         if (Channels.Lock(false, 10)) {
diff -ruN vdr-1.7.12/epg.c vdr-1.7.13/epg.c
--- vdr-1.7.12/epg.c	2010-01-08 16:20:28.000000000 +0100
+++ vdr-1.7.13/epg.c	2010-02-28 15:24:55.000000000 +0100
@@ -7,7 +7,7 @@
  * Original version (as used in VDR before 1.3.0) written by
  * Robert Schneider <Robert.Schneider@web.de> and Rolf Hakenes <hakenes@hippomi.de>.
  *
- * $Id: epg.c 2.5 2010/01/08 15:20:28 kls Exp $
+ * $Id: epg.c 2.6 2010/02/28 14:24:55 kls Exp $
  */
 
 #include "epg.h"
@@ -443,8 +443,6 @@
      if (components) {
         for (int i = 0; i < components->NumComponents(); i++) {
             tComponent *p = components->Component(i);
-            if (!Setup.UseDolbyDigital && p->stream == 0x02 && p->type == 0x05)
-               continue;
             fprintf(f, "%sX %s\n", Prefix, *p->ToString());
             }
         }
